
  *   Buggy Boy   Atari ST cartridge  version
   * Used NRV packing to fit in 128KB 

*Rom cartridge

  org $FA0000
 
  dc.l	$abcdef42     *magic
  dc.l	second
  dc.l 	$08000000+autorev    * Bit 27 set
* what means run before Disk-boot

  dc.l	autorev
  dc.w 	%0111101000100100   *time, GEMDOS format, 15 h, 17 min
  dc.w	%0011101011011010  *date - 2009, VI, 26 
  dc.l 	deskbugb-autorev
  dc.b	 "AUTOBB",0
    even

second
  dc.l 	0    * No more
  dc.l 	$40000000   * TOS app.
  dc.l 	deskbugb
  dc.w 	%0111101000100100   *time, GEMDOS format
  dc.w 	%0011101011011010 *date - 2009, VI, 26 
  dc.l 	end-deskbugb
  dc.b	"BUGGYBOY.TOS",0
  even



autorev	





	
	move.l	$432.w,a3   * Membot
	move.l	$436.w,a4    *Memtop
	
	move.w	#$0300,sr   *Set user mode

	lea	-8(a4),sp
	clr.l	(sp)
	move.l	a3,4(sp)

* Proper way is to do malloc here :


	sub.l	a3,a4
	pea	(a4)
	move.w	#$48,-(sp)
	trap	#1
	addq.l	#6,sp

* d0 should be here=4(sp)  !


deskbugb	*  Depack to basepage+256,
*relocate and run

	lea	gamnrv(pc),a3
	
	move.l	4(sp),a2      *Basepage
*	lea	228(a2),a4   *Depack with header
* With NRV by UPX little different :

	lea	256(a2),a4


	move.l	a2,-(sp)

	bsr	depakNRV

	move.l	(sp)+,a5   *Basepage
	lea	256(a5),a1   *code

* Put exec header on place :

	lea	-28(a4),a4
	lea	-28(a1),a3
	moveq	#6,d1
.thc	move.l	(a4),(a3)+
	clr.l	(a4)+
	dbf	d1,.thc


* Now reloc : 
	move.l     a1,a0
	lea  	-28(a0),a3   *Header
  	move.l     a1,d0
	add.l    	2(a3),a0   *Code  len for this prg
    	add.l    	6(a3),a0   *Data  len for this prg	

      	move.l	a0,a2 * reloc table begin


	tst.l	(a0)
	beq.s	corrbp *

	add.l	(a0)+,a1
	clr.l	d1
relol	add.l	d0,(a1)
bigd	
	move.b	(a0)+,d1
	beq.s	corrbp
	cmp.b	#1,d1
	bne.s	nmd
	lea	$FE(a1),a1
	bra.s	bigd
nmd	adda.l	d1,a1
	bra.s	relol
corrbp

	move.l	d0,8(a5)    * Replace  cart address with RAM address !

	MOVE.L	2(A3),$C(A5)
	MOVE.L	6(A3),$14(A5)
	MOVE.L	$A(A3),$1C(A5)
	MOVE.L	8(A5),D2
	MOVE.L	$C(A5),D1
	ADD.L	D2,D1
	MOVE.L	D1,$10(A5)
	MOVE.L	$14(A5),D2
	ADD.L	D2,D1
	MOVE.L	D1,$18(A5)


	lea  	6600(a0),a0


xy    	clr.l	(a2)+ * clear BSS area begin
        	cmp.l	a2,a0
       	bgt.s	xy 	  




	move.l	d0,a0


* Mshrink at start must be replaced with malloc !  : - here not, as did malloc before

*	lea	$CDD2-$CDB2(a0),a2
*	move.l	#$4E714E71,(a2)    * 2 pushes less

*	lea	$CDD8-$CDB2(a0),a2
*	move.w	#$48,(a2)      * change to Malloc

*	lea	$CDDE-$CDB2(a0),a2
*	move.w	#6,(a2)       * 6 bytes less on stack (instead 12)



* Here need to patch 2 file loading code :

	lea	$EF18-$CDB2(a0),a2
	move.w	#$601A,(a2)
	lea	$22(a2),a2
* Need to return to $EF76
	lea	$EF76-$CDB2(a0),a1   * ret address here
	move.w	#$43F9,(a2)+    * lea .. ,a1
	move.l	a1,(a2)+
	lea	li1(pc),a1
	move.w	#$4EF9,(a2)+
	move.l	a1,(a2)


	lea	$EF84-$CDB2(a0),a2

* Need to return to $EFA4
	lea	$EFA4-$CDB2(a0),a1   * ret address here
	move.w	#$43F9,(a2)+    * lea .. ,a1
	move.l	a1,(a2)+
	lea	li2,a1
	move.w	#$4EF9,(a2)+
	move.l	a1,(a2)


runGam	jmp	(a0)



li1	* Depak course file :

	move.l	(sp)+,a4
	lea	course(pc),a3
	bsr	depakNRV

	jmp	(a1)

li2
	move.l	(sp)+,a4
	lea	graph,a3
	bsr	depakNRV

	jmp	(a1)






depakNRV	

* a3 - src data pos.
* a4 - dest pos.

* From lower to higher, so  look it by overlap !


* Prepare :

   moveq  #-1,d5    * !
   moveq  #-128,d0
   moveq  #-1,d7
   moveq  #-104,d6   *  ???
   lsl.w  #5,d6

   bra.s   enterD
* 2+2+2+2+2=10


la74   move.b  (a3)+,(a4)+
enterD
la76  add.b  d0,d0    * this is la76 
   bcc.s   la82
   bne.s  la74
la7c  move.b  (a3)+,d0
   addx.b  d0,d0
   bcs.s  la74
la82  moveq  #1,d1
   moveq  #0,d3
la86   add.b  d0,d0
   bne.s  la8e
   move.b (a3)+,d0
   addx.b  d0,d0
la8e  addx.l  d1,d1
   add.b  d0,d0
   bcc.s  la86
   bne.s  la9c
   move.b  (a3)+,d0
   addx.b  d0,d0
   bcc.s  la86

la9c  subq.l  #3,d1
   bcs.s  laaa
   lsl.l  #8,d1
   move.b  (a3)+,d1
   not.l  d1
   beq.s  laf0
   move.l  d1,d5
laaa   add.b  d0,d0
   bne.s  lab2
   move.b  (a3)+,d0
  addx.b  d0,d0
lab2  addx.w  d3,d3
  add.b  d0,d0
   bne.s  labc
   move.b  (a3)+,d0
  addx.b  d0,d0
labc   addx.w  d3,d3
   tst.w  d3
   bne.s  ladc
   addq.w  #1,d3

lac4   add.b  d0,d0
   bne.s  lacc
   move.b  (a3)+,d0
   addx.b  d0,d0
lacc   addx.w  d3,d3
   add.b  d0,d0
   bcc.s  lac4
   bne.s  lada
   move.b  (a3)+,d0
   addx.b  d0,d0
   bcc.s  lac4
lada   addq.w  #2,d3
ladc   lea  0(a4,d5.l),a2
   move.l  d5,d1
   sub.l  d6,d1
   addx.w  d7,d3
   move.b  (a2)+,(a4)+
lae8   move.b  (a2)+,(a4)+
   dbf d3,lae8
   bra.s la76
*20+20+20=60 rows for dcore

laf0   *  done depacking !



   rts

* 126 + 10 = 136 bytes total for NRV2B depacker

	
* End of NRV depak



	even




gamnrv    incbin   "BB.TOS"
   

course	incbin  "C.TOS"

graph	incbin  "G.TOS"




   even




end




